helpdesk/helpdesk/urls.py
"""
django-helpdesk - A Django powered ticket tracker for small enterprise.

(c) Copyright 2008 Jutda. All Rights Reserved. See LICENSE for details.

urls.py - Mapping of URL's to our various views. Note we always used NAMED
          views for simplicity in linking later on.
"""

from django.conf.urls import url
from django.contrib.auth.decorators import login_required
from django.contrib.auth import views as auth_views
from django.views.generic import TemplateView

from helpdesk import settings as helpdesk_settings
from helpdesk.views import feeds, staff, public, kb, login


class DirectTemplateView(TemplateView):
    extra_context = None

    def get_context_data(self, **kwargs):
        context = super(self.__class__, self).get_context_data(**kwargs)
        if self.extra_context is not None:
            for key, value in self.extra_context.items():
                if callable(value):
                    context[key] = value()
                else:
                    context[key] = value
        return context


app_name = 'helpdesk'

urlpatterns = [
    url(r'^dashboard/$',
        staff.dashboard,
        name='dashboard'),

    url(r'^tickets/$',
        staff.ticket_list,
        name='list'),

    url(r'^tickets/update/$',
        staff.mass_update,
        name='mass_update'),

    url(r'^tickets/submit/$',
        staff.create_ticket,
        name='submit'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/$',
        staff.view_ticket,
        name='view'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/followup_edit/(?P<followup_id>[0-9]+)/$',
        staff.followup_edit,
        name='followup_edit'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/followup_delete/(?P<followup_id>[0-9]+)/$',
        staff.followup_delete,
        name='followup_delete'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/edit/$',
        staff.edit_ticket,
        name='edit'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/update/$',
        staff.update_ticket,
        name='update'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/delete/$',
        staff.delete_ticket,
        name='delete'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/hold/$',
        staff.hold_ticket,
        name='hold'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/unhold/$',
        staff.unhold_ticket,
        name='unhold'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/cc/$',
        staff.ticket_cc,
        name='ticket_cc'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/cc/add/$',
        staff.ticket_cc_add,
        name='ticket_cc_add'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/cc/delete/(?P<cc_id>[0-9]+)/$',
        staff.ticket_cc_del,
        name='ticket_cc_del'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/dependency/add/$',
        staff.ticket_dependency_add,
        name='ticket_dependency_add'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/dependency/delete/(?P<dependency_id>[0-9]+)/$',
        staff.ticket_dependency_del,
        name='ticket_dependency_del'),

    url(r'^tickets/(?P<ticket_id>[0-9]+)/attachment_delete/(?P<attachment_id>[0-9]+)/$',
        staff.attachment_del,
        name='attachment_del'),

    url(r'^raw/(?P<type>\w+)/$',
        staff.raw_details,
        name='raw'),

    url(r'^rss/$',
        staff.rss_list,
        name='rss_index'),

    url(r'^reports/$',
        staff.report_index,
        name='report_index'),

    url(r'^reports/(?P<report>\w+)/$',
        staff.run_report,
        name='run_report'),

    url(r'^save_query/$',
        staff.save_query,
        name='savequery'),

    url(r'^delete_query/(?P<id>[0-9]+)/$',
        staff.delete_saved_query,
        name='delete_query'),

    url(r'^settings/$',
        staff.user_settings,
        name='user_settings'),

    url(r'^ignore/$',
        staff.email_ignore,
        name='email_ignore'),

    url(r'^ignore/add/$',
        staff.email_ignore_add,
        name='email_ignore_add'),

    url(r'^ignore/delete/(?P<id>[0-9]+)/$',
        staff.email_ignore_del,
        name='email_ignore_del'),
]

urlpatterns += [
    url(r'^$',
        public.homepage,
        name='home'),

    url(r'^view/$',
        public.view_ticket,
        name='public_view'),

    url(r'^change_language/$',
        public.change_language,
        name='public_change_language'),
]

urlpatterns += [
    url(r'^rss/user/(?P<user_name>[^/]+)/$',
        login_required(feeds.OpenTicketsByUser()),
        name='rss_user'),

    url(r'^rss/user/(?P<user_name>[^/]+)/(?P<queue_slug>[A-Za-z0-9_-]+)/$',
        login_required(feeds.OpenTicketsByUser()),
        name='rss_user_queue'),

    url(r'^rss/queue/(?P<queue_slug>[A-Za-z0-9_-]+)/$',
        login_required(feeds.OpenTicketsByQueue()),
        name='rss_queue'),

    url(r'^rss/unassigned/$',
        login_required(feeds.UnassignedTickets()),
        name='rss_unassigned'),

    url(r'^rss/OtooV9ox1ahCaiquu2theeng/$',
        feeds.RecentFollowUps(),
        name='rss_activity'),

    url(r'^rss/recent_activity/$',
        login_required(feeds.RecentFollowUps()),
        name='rss_activity'),
]


urlpatterns += [
    url(r'^login/$',
        login.login,
        name='login'),

    url(r'^logout/$',
        auth_views.LogoutView.as_view(
            template_name='helpdesk/registration/login.html',
            next_page='../'),
        name='logout'),

    url(r'^password_change/$',
        auth_views.PasswordChangeView.as_view(
            template_name='helpdesk/registration/change_password.html',
            success_url='./done'),
        name='password_change'),

    url(r'^password_change/done$',
        auth_views.PasswordChangeDoneView.as_view(
            template_name='helpdesk/registration/change_password_done.html',),
        name='password_change_done'),
]

if helpdesk_settings.HELPDESK_KB_ENABLED:
    urlpatterns += [
        url(r'^kb/$',
            kb.index,
            name='kb_index'),

        url(r'^kb/(?P<item>[0-9]+)/$',
            kb.item,
            name='kb_item'),

        url(r'^kb/(?P<item>[0-9]+)/vote/$',
            kb.vote,
            name='kb_vote'),

        url(r'^kb/(?P<slug>[A-Za-z0-9_-]+)/$',
            kb.category,
            name='kb_category'),
    ]

urlpatterns += [
    url(r'^help/context/$',
        TemplateView.as_view(template_name='helpdesk/help_context.html'),
        name='help_context'),

    url(r'^system_settings/$',
        DirectTemplateView.as_view(template_name='helpdesk/system_settings.html'),
        name='system_settings'),
]

helpdesk/helpdesk/templates/helpdesk/include/stats.html
{% load i18n %}

            <div class="row">
                <div class="col-lg-12">
                    <div class="panel panel-primary">
                        <div class="panel-heading">
                            {% trans "Helpdesk Summary" %}
                        </div>
                        <!-- /.panel-heading -->
                        <div class="panel-body">
                            {% for entry in basic_ticket_stats.open_ticket_stats %}
                                <div class="col-lg-4 col-md-6">
                                    <div class="panel panel-{{ entry.2 }}">
                                        <div class="panel-heading">
                                            <div class="row">
                                                <div class="col-xs-3">
                                                    <i class="fa fa-calendar fa-5x"></i>
                                                </div>
                                                <div class="col-xs-9 text-right">
                                                    <div class="huge">{{ entry.1 }}</div>
                                                    <div>{{ entry.0 }}</div>
                                                </div>
                                            </div>
                                        </div>
                                        {% if entry.1 > 0 %}<a href="{% url 'helpdesk:list' %}?{{ entry.3 }}">{% else %}<a href="#">{% endif %}
                                            <div class="panel-footer">
                                                <span class="pull-left">{% if entry.1 > 0 %}{% trans "View Tickets" %}{% else %}{% trans "No tickets in this range" %}{% endif %}</span>
                                                {% if entry.1 > 0 %}<span class="pull-right"><i class="fa fa-arrow-circle-right"></i></span>{% endif %}
                                                <div class="clearfix"></div>
                                            </div>
                                        </a>
                                    </div>
                                </div>
                            {% endfor %}
                        </div>
                        <!-- /.panel-body -->
                    </div>
                    <!-- /.panel -->
                </div>
            </div>

helpdesk/helpdesk/templates/helpdesk/include/tickets.html
{% load i18n humanize %}

            <div class="row">
                <div class="col-lg-12">
                    <div class="panel panel-primary">
                        <div class="panel-heading">
                            {% if ticket_list_caption %}{{ ticket_list_caption }}{% else %}{% trans "Your Tickets" %}{% endif %}
                        </div>
                        <!-- /.panel-heading -->
                        <div class="panel-body">
                            <div class="table-responsive">
                                <table class="table table-striped table-bordered table-hover">
                                    <thead>
                                        <tr>
                                            <th>#</th>
                                            <th>{% trans "Pr" %}</th>
                                            <th>{% trans "Title" %}</th>
                                            <th>{% trans "Queue" %}</th>
                                            <th>{% trans "Status" %}</th>
                                            <th>{% trans "Last Update" %}</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        {% for ticket in ticket_list %}
                                        <tr class="{{ ticket.get_priority_css_class }}">
                                            <td><a href='{{ ticket.get_absolute_url }}'>{{ ticket.ticket }}</a></td>
                                            <td>{{ ticket.priority }}</td>
                                            <td><a href='{{ ticket.get_absolute_url }}'>{{ ticket.title }}</a></td>
                                            <td>{{ ticket.queue }}</td>
                                            <td>{{ ticket.get_status }}</td>
                                            <td><span title='{{ ticket.modified|date:"r" }}'>{{ ticket.modified|naturaltime }}</span></td>
                                        </tr>
                                        {% empty %}
                                        <tr>{% if ticket_list_empty_message %}<td colspan='6'>{{ ticket_list_empty_message }}</td>{% else %}<td colspan='6'>{% trans "You do not have any pending tickets." %}</td>{% endif %}</tr>
                                        {% endfor %}
                                    </tbody>
                                </table>
                            </div>
                            <!-- /.table-responsive -->
                            {% if ticket_list.has_other_pages %}
                                <ul class="pagination">
                                    <!-- if we aren't on page one, go back to start and go back one controls -->
                                    {% if ticket_list.has_previous %}
                                        <li><a href="?{{ page_var }}=1">&laquo;&laquo;</a></li>
                                        <li><a href="?{{ page_var }}={{ ticket_list.previous_page_number }}">&laquo;</a></li>
                                    {% else %}
                                        <li class="disabled"><span>&laquo;&laquo;</span></li>
                                        <li class="disabled"><span>&laquo;</span></li>
                                    {% endif %}
                                    <!-- other pages, set thresh to the number to show before and after active -->
                                    {% with 5 as thresh %}
                                    {% for i in ticket_list.paginator.page_range %}
                                        {% if ticket_list.number == i %}
                                            <li class="active"><span>{{ i }} <span class="sr-only">(current)</span></span></li>
                                        {% elif i <= ticket_list.number|add:5 and i >= ticket_list.number|add:-5 %}
                                            <li><a href="?{{ page_var }}={{ i }}">{{ i }}</a></li>
                                        {% endif %}
                                    {% endfor %}
                                    {% endwith %}
                                    <!-- if we aren't on the last page, go forward one and go to end controls -->
                                    {% if ticket_list.has_next %}
                                        <li><a href="?{{ page_var }}={{ ticket_list.next_page_number }}">&raquo;</a></li>
                                        <li><a href="?{{ page_var }}={{ ticket_list.paginator.num_pages }}">&raquo;&raquo;</a></li>
                                    {% else %}
                                        <li class="disabled"><span>&raquo;</span></li>
                                        <li class="disabled"><span>&raquo;&raquo;</span></li>
                                    {% endif %}
                                </ul>
                            {% endif %}
                        </div>
                        <!-- /.panel-body -->
                    </div>
                    <!-- /.panel -->
                </div>
            </div>

helpdesk/helpdesk/templates/helpdesk/include/unassigned.html
{% load i18n humanize %}

            <div class="row">
                <div class="col-lg-12">
                    <div class="panel panel-primary">
                        <div class="panel-heading">
                            {% trans "Unassigned Tickets" %} {% trans "(pick up a ticket if you start to work on it)" %}
                        </div>
                        <!-- /.panel-heading -->
                        <div class="panel-body">
                            <div class="table-responsive">
                                <table class="table table-striped table-bordered table-hover">
                                    <thead>
                                        <tr>
                                            <th>#</th>
                                            <th>{% trans "Pr" %}</th>
                                            <th>{% trans "Title" %}</th>
                                            <th>{% trans "Queue" %}</th>
                                            <th>{% trans "Created" %}</th>
                                            <th>&nbsp;</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        {% for ticket in unassigned_tickets %}
                                        <tr class="{{ ticket.get_priority_css_class }}">
                                            <td><a href='{{ ticket.get_absolute_url }}'>{{ ticket.ticket }}</a></td>
                                            <td>{{ ticket.priority }}</td>
                                            <td><a href='{{ ticket.get_absolute_url }}'>{{ ticket.title }}</a></td>
                                            <td>{{ ticket.queue }}</td>
                                            <td><span title='{{ ticket.created|date:"r" }}'>{{ ticket.created|naturaltime }}</span></td>
                                            <td>
                                                <a href='{{ ticket.get_absolute_url }}?take'><button class='btn btn-primary btn-xs'><i class="fa fa-hand-paper-o"></i>&nbsp;{% trans "Take" %}</button></a> |
                                                <a href='{% url 'helpdesk:delete' ticket.id %}'><button class='btn btn-danger btn-xs'><i class="fa fa-trash"></i>&nbsp;{% trans "Delete" %}</button></a>
                                            </td>
                                        </tr>
                                        {% empty %}
                                        <tr><td colspan='6'>{% trans "There are no unassigned tickets." %}</td></tr>
                                        {% endfor %}
                                    </tbody>
                                </table>
                            </div>
                            <!-- /.table-responsive -->
                        </div>
                        <!-- /.panel-body -->
                    </div>
                    <!-- /.panel -->
                </div>
            </div>